
_write2bytes:

;ATmega644P_AD7656_ExtInt.c,7 :: 		int16_t write2bytes(uint16_t command) {
;ATmega644P_AD7656_ExtInt.c,11 :: 		higherByte = (uint8_t)((command & 0xFF00) >> 8);
	MOVW       R16, R2
	ANDI       R16, 0
	ANDI       R17, 255
	MOV        R18, R17
	LDI        R19, 0
;ATmega644P_AD7656_ExtInt.c,12 :: 		lowerByte = (uint8_t)(command & 0x00FF);
	MOV        R16, R2
	ANDI       R16, 255
; lowerByte start address is: 16 (R16)
;ATmega644P_AD7656_ExtInt.c,14 :: 		SPDR = higherByte;  // sending high byte first
	OUT        SPDR+0, R18
; lowerByte end address is: 16 (R16)
	MOV        R18, R16
;ATmega644P_AD7656_ExtInt.c,15 :: 		while(!(SPSR & (1<<SPIF)));
L_write2bytes0:
; lowerByte start address is: 18 (R18)
	IN         R16, SPSR+0
	SBRC       R16, 7
	JMP        L_write2bytes1
	JMP        L_write2bytes0
L_write2bytes1:
;ATmega644P_AD7656_ExtInt.c,16 :: 		result = SPDR & 0xFF;
	IN         R16, SPDR+0
	ANDI       R16, 255
; result start address is: 19 (R19)
	MOV        R19, R16
	LDI        R20, 0
;ATmega644P_AD7656_ExtInt.c,17 :: 		result <<= 8;
	MOV        R17, R19
	CLR        R16
; result end address is: 19 (R19)
; result start address is: 16 (R16)
;ATmega644P_AD7656_ExtInt.c,18 :: 		SPDR = lowerByte;  // sending low byte
	OUT        SPDR+0, R18
; lowerByte end address is: 18 (R18)
; result end address is: 16 (R16)
	MOVW       R18, R16
;ATmega644P_AD7656_ExtInt.c,19 :: 		while(!(SPSR & (1<<SPIF)));
L_write2bytes2:
; result start address is: 18 (R18)
	IN         R16, SPSR+0
	SBRC       R16, 7
	JMP        L_write2bytes3
	JMP        L_write2bytes2
L_write2bytes3:
;ATmega644P_AD7656_ExtInt.c,20 :: 		result |= SPDR;
	IN         R16, SPDR+0
	LDI        R17, 0
	OR         R16, R18
	OR         R17, R19
; result end address is: 18 (R18)
;ATmega644P_AD7656_ExtInt.c,22 :: 		return result;
;ATmega644P_AD7656_ExtInt.c,23 :: 		}//write2bytes
L_end_write2bytes:
	RET
; end of _write2bytes

_SPI_init:

;ATmega644P_AD7656_ExtInt.c,25 :: 		uint8_t SPI_init(void) {
;ATmega644P_AD7656_ExtInt.c,27 :: 		DDB6_bit = 0;              // Set PB6 pin as input (MISO)
	PUSH       R2
	PUSH       R3
	PUSH       R4
	IN         R27, DDB6_bit+0
	CBR        R27, BitMask(DDB6_bit+0)
	OUT        DDB6_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,28 :: 		DDB5_bit = 1;              // Set PB5 pin as output (MOSI)
	IN         R27, DDB5_bit+0
	SBR        R27, BitMask(DDB5_bit+0)
	OUT        DDB5_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,29 :: 		Chip_Select = 1;           // Deselect ADC
	IN         R27, PORTB4_bit+0
	SBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,30 :: 		Chip_Select_Direction = 1; // Set CS# pin as Output
	IN         R27, DDB4_bit+0
	SBR        R27, BitMask(DDB4_bit+0)
	OUT        DDB4_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,31 :: 		SPI1_Init_Advanced(_SPI_MASTER, _SPI_FCY_DIV128, _SPI_CLK_LO_LEADING);
	CLR        R4
	LDI        R27, 3
	MOV        R3, R27
	LDI        R27, 16
	MOV        R2, R27
	CALL       _SPI1_Init_Advanced+0
;ATmega644P_AD7656_ExtInt.c,33 :: 		return 0;
	LDI        R16, 0
;ATmega644P_AD7656_ExtInt.c,34 :: 		}//SPI_init
;ATmega644P_AD7656_ExtInt.c,33 :: 		return 0;
;ATmega644P_AD7656_ExtInt.c,34 :: 		}//SPI_init
L_end_SPI_init:
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _SPI_init

_sendThroughUART:

;ATmega644P_AD7656_ExtInt.c,36 :: 		uint8_t sendThroughUART(char *text_) {
;ATmega644P_AD7656_ExtInt.c,38 :: 		UART1_Write_Text(text_);
	PUSH       R2
	PUSH       R3
	CALL       _UART1_Write_Text+0
;ATmega644P_AD7656_ExtInt.c,39 :: 		UART1_Write(13);
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
;ATmega644P_AD7656_ExtInt.c,40 :: 		UART1_Write(10);
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ATmega644P_AD7656_ExtInt.c,42 :: 		return 0;
	LDI        R16, 0
;ATmega644P_AD7656_ExtInt.c,43 :: 		}//sendThroughUART
;ATmega644P_AD7656_ExtInt.c,42 :: 		return 0;
;ATmega644P_AD7656_ExtInt.c,43 :: 		}//sendThroughUART
L_end_sendThroughUART:
	POP        R3
	POP        R2
	RET
; end of _sendThroughUART

_startSampling:

;ATmega644P_AD7656_ExtInt.c,45 :: 		uint8_t startSampling(void) {
;ATmega644P_AD7656_ExtInt.c,47 :: 		PORTA.F0 = 0;    // CONVSTA = LOW
	IN         R27, PORTA+0
	CBR        R27, 1
	OUT        PORTA+0, R27
;ATmega644P_AD7656_ExtInt.c,50 :: 		Delay_us(1);
	LDI        R16, 6
L_startSampling4:
	DEC        R16
	BRNE       L_startSampling4
	NOP
	NOP
;ATmega644P_AD7656_ExtInt.c,51 :: 		PORTA.F0 = 1;    // CONVSTA = HIGH
	IN         R27, PORTA+0
	SBR        R27, 1
	OUT        PORTA+0, R27
;ATmega644P_AD7656_ExtInt.c,55 :: 		return 0;
	LDI        R16, 0
;ATmega644P_AD7656_ExtInt.c,56 :: 		}//startSampling
L_end_startSampling:
	RET
; end of _startSampling

_readADC:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 2
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;ATmega644P_AD7656_ExtInt.c,59 :: 		uint8_t readADC(void) {
;ATmega644P_AD7656_ExtInt.c,62 :: 		Chip_Select = 0; // Select chip
	PUSH       R2
	PUSH       R3
	IN         R27, PORTB4_bit+0
	CBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,63 :: 		PORTA.F4 = 0;    // Select RD pin
	IN         R27, PORTA+0
	CBR        R27, 16
	OUT        PORTA+0, R27
;ATmega644P_AD7656_ExtInt.c,64 :: 		for (j = 0; j < 6; j++) // Loop through all six channels getting the high byte, then the low, and moving on to next channel
; j start address is: 20 (R20)
	LDI        R20, 0
; j end address is: 20 (R20)
L_readADC6:
; j start address is: 20 (R20)
	CPI        R20, 6
	BRLO       L__readADC23
	JMP        L_readADC7
L__readADC23:
;ATmega644P_AD7656_ExtInt.c,65 :: 		VBs[j] = write2bytes(0x0000);
	MOV        R18, R20
	LDI        R19, 0
	LSL        R18
	ROL        R19
	LDI        R16, #lo_addr(_VBs+0)
	LDI        R17, hi_addr(_VBs+0)
	ADD        R16, R18
	ADC        R17, R19
	STD        Y+0, R16
	STD        Y+1, R17
	PUSH       R20
	CLR        R2
	CLR        R3
	CALL       _write2bytes+0
	POP        R20
	LDD        R18, Y+0
	LDD        R19, Y+1
	MOVW       R30, R18
	ST         Z+, R16
	ST         Z+, R17
;ATmega644P_AD7656_ExtInt.c,64 :: 		for (j = 0; j < 6; j++) // Loop through all six channels getting the high byte, then the low, and moving on to next channel
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
;ATmega644P_AD7656_ExtInt.c,65 :: 		VBs[j] = write2bytes(0x0000);
; j end address is: 20 (R20)
	JMP        L_readADC6
L_readADC7:
;ATmega644P_AD7656_ExtInt.c,66 :: 		PORTA.F4 = 1;    // Deselect RD pin
	IN         R27, PORTA+0
	SBR        R27, 16
	OUT        PORTA+0, R27
;ATmega644P_AD7656_ExtInt.c,67 :: 		Chip_Select = 1; // Deselect chip
	IN         R27, PORTB4_bit+0
	SBR        R27, BitMask(PORTB4_bit+0)
	OUT        PORTB4_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,69 :: 		return 0;
	LDI        R16, 0
;ATmega644P_AD7656_ExtInt.c,70 :: 		}//readADC
;ATmega644P_AD7656_ExtInt.c,69 :: 		return 0;
;ATmega644P_AD7656_ExtInt.c,70 :: 		}//readADC
L_end_readADC:
	POP        R3
	POP        R2
	ADIW       R28, 1
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _readADC

_processData:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 16
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;ATmega644P_AD7656_ExtInt.c,72 :: 		uint8_t processData(void) {
;ATmega644P_AD7656_ExtInt.c,73 :: 		uint16_t result = 0;
	PUSH       R2
	PUSH       R3
;ATmega644P_AD7656_ExtInt.c,77 :: 		for (j = 0; j < 6; j++) {
; j start address is: 20 (R20)
	LDI        R20, 0
; j end address is: 20 (R20)
L_processData9:
; j start address is: 20 (R20)
	CPI        R20, 6
	BRLO       L__processData25
	JMP        L_processData10
L__processData25:
;ATmega644P_AD7656_ExtInt.c,78 :: 		result = VBs[j];
	MOV        R18, R20
	LDI        R19, 0
	LSL        R18
	ROL        R19
	LDI        R16, #lo_addr(_VBs+0)
	LDI        R17, hi_addr(_VBs+0)
	MOVW       R30, R18
	ADD        R30, R16
	ADC        R31, R17
	LD         R18, Z+
	LD         R19, Z+
;ATmega644P_AD7656_ExtInt.c,79 :: 		sprintf(buffer, "%d", result);
	MOVW       R16, R28
	PUSH       R20
	PUSH       R19
	PUSH       R18
	LDI        R27, hi_addr(?lstr_1_ATmega644P_AD7656_ExtInt+0)
	PUSH       R27
	LDI        R27, #lo_addr(?lstr_1_ATmega644P_AD7656_ExtInt+0)
	PUSH       R27
	PUSH       R17
	PUSH       R16
	CALL       _sprintf+0
	IN         R26, SPL+0
	IN         R27, SPL+1
	ADIW       R26, 6
	OUT        SPL+0, R26
	OUT        SPL+1, R27
	POP        R20
;ATmega644P_AD7656_ExtInt.c,80 :: 		sendThroughUART(buffer);
	MOVW       R16, R28
	MOVW       R2, R16
	CALL       _sendThroughUART+0
;ATmega644P_AD7656_ExtInt.c,77 :: 		for (j = 0; j < 6; j++) {
	MOV        R16, R20
	SUBI       R16, 255
	MOV        R20, R16
;ATmega644P_AD7656_ExtInt.c,81 :: 		}//for_j
; j end address is: 20 (R20)
	JMP        L_processData9
L_processData10:
;ATmega644P_AD7656_ExtInt.c,83 :: 		UART1_Write_Text("END OF CONVERSION"); UART1_Write(13); UART1_Write(10);
	LDI        R27, #lo_addr(?lstr2_ATmega644P_AD7656_ExtInt+0)
	MOV        R2, R27
	LDI        R27, hi_addr(?lstr2_ATmega644P_AD7656_ExtInt+0)
	MOV        R3, R27
	CALL       _UART1_Write_Text+0
	LDI        R27, 13
	MOV        R2, R27
	CALL       _UART1_Write+0
	LDI        R27, 10
	MOV        R2, R27
	CALL       _UART1_Write+0
;ATmega644P_AD7656_ExtInt.c,85 :: 		return 0;
	LDI        R16, 0
;ATmega644P_AD7656_ExtInt.c,86 :: 		}//processData
;ATmega644P_AD7656_ExtInt.c,85 :: 		return 0;
;ATmega644P_AD7656_ExtInt.c,86 :: 		}//processData
L_end_processData:
	POP        R3
	POP        R2
	ADIW       R28, 15
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _processData

_interrupt_ISR:
	PUSH       R30
	PUSH       R31
	PUSH       R27
	IN         R27, SREG+0
	PUSH       R27

;ATmega644P_AD7656_ExtInt.c,88 :: 		void interrupt_ISR () org IVT_ADDR_INT0 {
;ATmega644P_AD7656_ExtInt.c,90 :: 		SREG_I_bit = 0;        // Disable interrupts
	IN         R27, SREG_I_bit+0
	CBR        R27, BitMask(SREG_I_bit+0)
	OUT        SREG_I_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,91 :: 		readADC();
	CALL       _readADC+0
;ATmega644P_AD7656_ExtInt.c,92 :: 		SREG_I_bit = 1;        // Enable interrupts
	IN         R27, SREG_I_bit+0
	SBR        R27, BitMask(SREG_I_bit+0)
	OUT        SREG_I_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,94 :: 		return;
;ATmega644P_AD7656_ExtInt.c,95 :: 		}//interrupt_ISR
L_end_interrupt_ISR:
	POP        R27
	OUT        SREG+0, R27
	POP        R27
	POP        R31
	POP        R30
	RETI
; end of _interrupt_ISR

_init:

;ATmega644P_AD7656_ExtInt.c,97 :: 		uint8_t init(void) {
;ATmega644P_AD7656_ExtInt.c,99 :: 		DDA0_bit = 1; // Set PA0 as output (CONVSTA)
	IN         R27, DDA0_bit+0
	SBR        R27, BitMask(DDA0_bit+0)
	OUT        DDA0_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,100 :: 		DDA1_bit = 1; // Set PA1 as output (CONVSTB)
	IN         R27, DDA1_bit+0
	SBR        R27, BitMask(DDA1_bit+0)
	OUT        DDA1_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,101 :: 		DDA2_bit = 1; // Set PA2 as output (CONVSTC)
	IN         R27, DDA2_bit+0
	SBR        R27, BitMask(DDA2_bit+0)
	OUT        DDA2_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,103 :: 		DDA4_bit = 1; // Set PA4 as output (RD)
	IN         R27, DDA4_bit+0
	SBR        R27, BitMask(DDA4_bit+0)
	OUT        DDA4_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,105 :: 		SPI_init();
	CALL       _SPI_init+0
;ATmega644P_AD7656_ExtInt.c,106 :: 		UART1_Init(57600);
	LDS        R27, U2X0_bit+0
	SBR        R27, BitMask(U2X0_bit+0)
	STS        U2X0_bit+0, R27
	LDI        R27, 42
	STS        UBRR0L+0, R27
	LDI        R27, 0
	STS        UBRR0H+0, R27
	CALL       _UART1_Init+0
;ATmega644P_AD7656_ExtInt.c,107 :: 		Delay_ms(100);
	LDI        R18, 11
	LDI        R17, 38
	LDI        R16, 94
L_init12:
	DEC        R16
	BRNE       L_init12
	DEC        R17
	BRNE       L_init12
	DEC        R18
	BRNE       L_init12
	NOP
	NOP
;ATmega644P_AD7656_ExtInt.c,108 :: 		PORTA.F0 = 1;    // CONVSTA = idle HIGH
	IN         R27, PORTA+0
	SBR        R27, 1
	OUT        PORTA+0, R27
;ATmega644P_AD7656_ExtInt.c,112 :: 		EICRA = 0b00000010;   // The falling edge of INT0 generates an interrupt request (BUSY line goes here)
	LDI        R27, 2
	STS        EICRA+0, R27
;ATmega644P_AD7656_ExtInt.c,113 :: 		EIMSK = 0b00000001;   // External interrupt request 0 enable
	LDI        R27, 1
	OUT        EIMSK+0, R27
;ATmega644P_AD7656_ExtInt.c,114 :: 		SREG_I_bit = 1;       // Enable interrupts
	IN         R27, SREG_I_bit+0
	SBR        R27, BitMask(SREG_I_bit+0)
	OUT        SREG_I_bit+0, R27
;ATmega644P_AD7656_ExtInt.c,116 :: 		return 0;
	LDI        R16, 0
;ATmega644P_AD7656_ExtInt.c,117 :: 		}//init
L_end_init:
	RET
; end of _init

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;ATmega644P_AD7656_ExtInt.c,119 :: 		void main() {
;ATmega644P_AD7656_ExtInt.c,121 :: 		init();
	CALL       _init+0
;ATmega644P_AD7656_ExtInt.c,123 :: 		while (1) {
L_main14:
;ATmega644P_AD7656_ExtInt.c,124 :: 		startSampling();
	CALL       _startSampling+0
;ATmega644P_AD7656_ExtInt.c,125 :: 		processData();
	CALL       _processData+0
;ATmega644P_AD7656_ExtInt.c,126 :: 		Delay_ms(100);
	LDI        R18, 11
	LDI        R17, 38
	LDI        R16, 94
L_main16:
	DEC        R16
	BRNE       L_main16
	DEC        R17
	BRNE       L_main16
	DEC        R18
	BRNE       L_main16
	NOP
	NOP
;ATmega644P_AD7656_ExtInt.c,127 :: 		}//while
	JMP        L_main14
;ATmega644P_AD7656_ExtInt.c,130 :: 		}//main
L_end_main:
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
